/* x86/coreisbr gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007,
2008, 2009, 2010, 2011 Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 3 of the License, or (at your
option) any later version.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.  */

#define GMP_LIMB_BITS 32
#define BYTES_PER_MP_LIMB 4

/* Generated by tuneup.c, 2011-11-24, gcc 4.2 */

#define MOD_1_NORM_THRESHOLD                24
#define MOD_1_UNNORM_THRESHOLD              25
#define MOD_1N_TO_MOD_1_1_THRESHOLD          7
#define MOD_1U_TO_MOD_1_1_THRESHOLD          7
#define MOD_1_1_TO_MOD_1_2_THRESHOLD        11
#define MOD_1_2_TO_MOD_1_4_THRESHOLD         0  /* never mpn_mod_1s_2p */
#define PREINV_MOD_1_TO_MOD_1_THRESHOLD      3
#define USE_PREINV_DIVREM_1                  1  /* native */
#define DIV_QR_2_PI2_THRESHOLD           MP_SIZE_T_MAX  /* never */
#define DIVEXACT_1_THRESHOLD                 0  /* always (native) */
#define BMOD_1_TO_MOD_1_THRESHOLD           18

#define MUL_TOOM22_THRESHOLD                28
#define MUL_TOOM33_THRESHOLD               101
#define MUL_TOOM44_THRESHOLD               244
#define MUL_TOOM6H_THRESHOLD               351
#define MUL_TOOM8H_THRESHOLD               547

#define MUL_TOOM32_TO_TOOM43_THRESHOLD     109
#define MUL_TOOM32_TO_TOOM53_THRESHOLD     183
#define MUL_TOOM42_TO_TOOM53_THRESHOLD     109
#define MUL_TOOM42_TO_TOOM63_THRESHOLD     109

#define SQR_BASECASE_THRESHOLD               0  /* always (native) */
#define SQR_TOOM2_THRESHOLD                 48
#define SQR_TOOM3_THRESHOLD                165
#define SQR_TOOM4_THRESHOLD                276
#define SQR_TOOM6_THRESHOLD                366
#define SQR_TOOM8_THRESHOLD                572

#define MULMID_TOOM42_THRESHOLD             98

#define MULMOD_BNM1_THRESHOLD               20
#define SQRMOD_BNM1_THRESHOLD               23

#define POWM_SEC_TABLE  2,27,258,1052

#define MUL_FFT_MODF_THRESHOLD             716  /* k = 5 */
#define MUL_FFT_TABLE3                                      \
  { {    716, 5}, {     27, 6}, {     15, 5}, {     31, 6}, \
    {     27, 7}, {     15, 6}, {     33, 7}, {     17, 6}, \
    {     35, 7}, {     19, 6}, {     39, 7}, {     23, 6}, \
    {     47, 7}, {     27, 8}, {     15, 7}, {     31, 6}, \
    {     63, 7}, {     35, 8}, {     19, 7}, {     41, 8}, \
    {     23, 7}, {     51, 8}, {     31, 7}, {     63, 8}, \
    {     43, 9}, {     23, 8}, {     55, 9}, {     31, 8}, \
    {     71, 9}, {     39, 8}, {     79, 9}, {     47, 8}, \
    {     95, 9}, {     55,10}, {     31, 9}, {     63, 8}, \
    {    127, 9}, {     79,10}, {     47, 9}, {     95,11}, \
    {     31,10}, {     63, 9}, {    135,10}, {     79, 9}, \
    {    159,10}, {     95, 9}, {    191,11}, {     63,10}, \
    {    127, 9}, {    255,10}, {    159,11}, {     95,10}, \
    {    191,12}, {     63,11}, {    127,10}, {    255, 9}, \
    {    511,10}, {    271,11}, {    159,10}, {    319, 9}, \
    {    639,11}, {    191,10}, {    383, 9}, {    767,11}, \
    {    223,12}, {   4096,13}, {   8192,14}, {  16384,15}, \
    {  32768,16} }
#define MUL_FFT_TABLE3_SIZE 69
#define MUL_FFT_THRESHOLD                 7552

#define SQR_FFT_MODF_THRESHOLD             595  /* k = 5 */
#define SQR_FFT_TABLE3                                      \
  { {    595, 5}, {     28, 6}, {     15, 5}, {     31, 6}, \
    {     29, 7}, {     15, 6}, {     33, 7}, {     17, 6}, \
    {     35, 7}, {     19, 6}, {     39, 7}, {     23, 6}, \
    {     47, 7}, {     35, 8}, {     19, 7}, {     43, 8}, \
    {     23, 7}, {     49, 8}, {     31, 7}, {     63, 8}, \
    {     43, 9}, {     23, 8}, {     55, 9}, {     31, 8}, \
    {     67, 9}, {     39, 8}, {     79, 9}, {     47, 8}, \
    {     95, 9}, {     55,10}, {     31, 9}, {     63, 8}, \
    {    127, 9}, {     79,10}, {     47, 9}, {     95,11}, \
    {     31,10}, {     63, 9}, {    135,10}, {     79, 9}, \
    {    159,10}, {     95,11}, {     63,10}, {    159,11}, \
    {     95,10}, {    191,12}, {     63,11}, {    127,10}, \
    {    255, 9}, {    511,10}, {    271, 9}, {    543,11}, \
    {    159,10}, {    319, 9}, {    671,11}, {    191,10}, \
    {    383, 9}, {    767,10}, {    399,12}, {   4096,13}, \
    {   8192,14}, {  16384,15}, {  32768,16} }
#define SQR_FFT_TABLE3_SIZE 63
#define SQR_FFT_THRESHOLD                 5760

#define MULLO_BASECASE_THRESHOLD             0  /* always */
#define MULLO_DC_THRESHOLD                 100
#define MULLO_MUL_N_THRESHOLD            14379

#define DC_DIV_QR_THRESHOLD                 22
#define DC_DIVAPPR_Q_THRESHOLD              30
#define DC_BDIV_QR_THRESHOLD               120
#define DC_BDIV_Q_THRESHOLD                268

#define INV_MULMOD_BNM1_THRESHOLD           54
#define INV_NEWTON_THRESHOLD                12
#define INV_APPR_THRESHOLD                  13

#define BINV_NEWTON_THRESHOLD              410
#define REDC_1_TO_REDC_N_THRESHOLD         100

#define MU_DIV_QR_THRESHOLD               1037
#define MU_DIVAPPR_Q_THRESHOLD             889
#define MUPI_DIV_QR_THRESHOLD                0  /* always */
#define MU_BDIV_QR_THRESHOLD              1858
#define MU_BDIV_Q_THRESHOLD               2172

#define MATRIX22_STRASSEN_THRESHOLD         21
#define HGCD_THRESHOLD                      59
#define HGCD_APPR_THRESHOLD                 56
#define HGCD_REDUCE_THRESHOLD             4818
#define GCD_DC_THRESHOLD                   278
#define GCDEXT_DC_THRESHOLD                298
#define JACOBI_BASE_METHOD                   4

#define GET_STR_DC_THRESHOLD                11
#define GET_STR_PRECOMPUTE_THRESHOLD        23
#define SET_STR_DC_THRESHOLD               438
#define SET_STR_PRECOMPUTE_THRESHOLD      1206
